{-------------------------------------------------------------------------
    KOCKA.PAS A GDI felhasznlsval megrt 3D-s animci.
	      Konkrtan egy kocka forgatsa trben.
--------------------------------------------------------------------------}


program Kocka_forgatas;

uses WinTypes, WinProcs, Strings;
{$R kocka.res}

const
 IDS_APPNAME   = 2000;
 IDS_APPTITLE  = 2001;
 TIMER         = 1;
 TIME          = 100;
 MAX_APPNAME   =   9;
 MAX_APPTITLE  =  80;
 MAX_STRING    = 128;
 MAX_CUBE_COORDS  =  8;
 MAX_CUBE_LINES   = 12;


function AllocMem(Bytes: LongInt): THandle;
begin
  AllocMem := GlobalAlloc(GMEM_MOVEABLE or GMEM_ZEROINIT,Bytes);
end;

type

LPPOINT= ^TPOINT;
TAPOINTS = Array[0..MAX_CUBE_COORDS-1] of TPOINT;
PAPOINTS =^TAPOINTS;

{ 3D pont koordinti }
LPCOORD = ^COORD;
COORD = record
  x, y, z : integer;
end;

TACOORDS = Array[0..MAX_CUBE_COORDS-1] of COORD;
PACOORDS =^TACOORDS;

{ EGYENES : kt ponttal megadva }
LPLINE = ^LINE;
LINE = record
   _From, _To: integer;
end;

TALINES = Array[0..MAX_CUBE_LINES-1] of LINE;
PALINES = ^TALINES;

{ A 3D-s objektum lerst tartalmaz rekord}
LPDESCRIPT = ^DESCRIPT;
DESCRIPT = record
  MaxCoords : Integer;
  lpC       : PACOORDS;
  MaxLines  : Integer;
  lpL       : PALINES;
end;

{ Az objektum adatait tartalmaz struktra }
LPCObject = ^CObject;
CObject = record
  bIsDrawn   : BOOL ;
  hPen       : THandle;
  hPoints    : THandle;
  hOldPoints : THandle;
  lpD        : DESCRIPT;
end;

{ View definci }
LPView = ^TView;
TView = record
  Alpha : real;
  Beta  : real;
  Rect  : TRect;
end;


const

 { A kockt definil trbeli pontok megadsa }
 cCube :TACOORDS =
                 ((x:-100;y:-100;z:-100),
                  (x: 100;y:-100;z:-100),
                  (x: 100;y: 100;z:-100),
                  (x:-100;y: 100;z:-100),
                  (x:-100;y:-100;z: 100),
                  (x: 100;y:-100;z: 100),
                  (x: 100;y: 100;z: 100),
                  (x:-100;y: 100;z: 100));


{ A pontok sszektsnek definilsa }
lCube: TALINES =
 ((_from:0;_to:1), (_from:1;_to:2), (_from:2;_to:3), (_from:3;_to:0),
  (_from:4;_to:5), (_from:5;_to:6), (_from:6;_to:7), (_from:7;_to:4),
  (_from:0;_to:4), (_from:1;_to:5), (_from:2;_to:6), (_from:3;_to:7));

{ A kocka teljes definilsa }
dCube : DESCRIPT = (
  MaxCoords : MAX_CUBE_COORDS;
  lpC       : @cCube;
  MaxLines  : MAX_CUBE_LINES;
  lpL       : @lCube
);

bInitOk :BOOL     = FALSE;

var
  Obj  : CObject;
  View : TView;


{-------------------------------------------------------------------------
    Erforrs sztring msolsa C sztringbe
--------------------------------------------------------------------------}

function CpyTxt (Str : PChar ; wIDC : word) : PChar;
var
 Str1: Array [0..MAX_STRING] of char;
begin
 LoadString(hInstance, wIDC, Str1, MAX_STRING-1);
 strcopy (Str, Str1);
 CpyTxt := Str;
end;


{-------------------------------------------------------------------------
  Az j objektum ltrehozsa a lerja megadsval
--------------------------------------------------------------------------}

function CreateObject(var lpO : CObject; lpD : DESCRIPT;
                      dwRgb : Longint): BOOL;
var
 bResult :BOOL;
begin
 bResult := FALSE;
 lpO.lpD := lpD;
 lpO.hPen:=CreatePen(PS_SOLID, 1, dwRgb);
 if (lpO.hPen<>0) then
 begin
  lpO.hPoints:=AllocMem(sizeof(TPOINT)*lpD.MaxCoords);
  if (lpO.hPoints<>0) then
  begin
   lpO.hOldPoints:=AllocMem(sizeof(TPOINT)*lpD.MaxCoords);
   if (lpO.hOldPoints<>0)then
   begin
     lpO.bIsDrawn := FALSE;
     bResult := TRUE;
   end;
  end;
 end;
 CreateObject:=bResult;
end;


{-------------------------------------------------------------------------
    Objektum trlse
--------------------------------------------------------------------------}

procedure DeleteLPObject (var lpO : CObject);
begin
  lpo.lpd.MaxCoords := 0;
  lpO.lpD.lpC       := nil;
  lpO.lpD.MaxLines  := 0;
  lpO.lpD.lpL       :=nil;
  DeleteObject (lpO.hPen);
  GlobalFree (lpO.hPoints);
  GlobalFree (lpO.hOldPoints);
end;


{-------------------------------------------------------------------------
    Adott objektum, adott view-ra trtn lekpezse
--------------------------------------------------------------------------}

procedure ProjectObject (var lpV : TVIEW; var lpO : CObject);
var
  i : integer;
  SinAlpha, CosAlpha : real;
  SinBeta,  CosBeta : real;
  lpP    : PAPOINTS;
  lpOldP : PAPOINTS;
  lpC    : TACOORDS;
  C      : COORD;

begin
 lpP := PAPOINTS(GlobalLock (lpO.hPoints));
 if Assigned(lpP) then
 begin
  lpOldP := PAPOINTS(GlobalLock(lpO.hOldPoints));
  if Assigned(lpOldP) then
  begin
    SinAlpha := sin (lpV.Alpha);
    CosAlpha := cos (lpV.Alpha);
    SinBeta  := sin (lpV.Beta);
    CosBeta  := cos (lpV.Beta);
    lpC:=lpO.lpD.lpC^;

    for  i:=0 to lpO.lpD.MaxCoords-1 do
    begin
     C := lpC[i];
     lpOldP^[i] := lpP^[i];
     lpP^[i].x := (lpV.Rect.right div 2) + round(C.x*CosBeta-C.z*SinBeta);
     lpP^[i].y := (lpV.Rect.bottom div 2)+
                  round(C.x*SinAlpha*SinBeta+C.y*CosAlpha+C.z*SinAlpha*CosBeta);
    end;
    GlobalUnLock (lpO.hOldPoints);
  end;
  GlobalUnLock (lpO.hPoints);
 end;
end;


{-------------------------------------------------------------------------
    Objektum rajzolsa adott eszkzkapcsolatra (hDC)
--------------------------------------------------------------------------}

procedure _ShowObject(_hDC :HDC; lpP :TAPOINTS; lpL: TALINES;
                      MaxLines : integer);
var
 i: integer;
begin
 for i := 0 to  MaxLines-1 do
 begin
  MoveTo (_hDC, lpP[lpL[i]._From].x,
	        lpP[lpL[i]._From].y);
  LineTo (_hDC, lpP[lpL[i]._To].x,
	        lpP[lpL[i]._To].y);
 end;
end;


{-------------------------------------------------------------------------
    Objektum megjelentse
--------------------------------------------------------------------------}

procedure ShowObject (_hDC: HDC; lpO :  CObject);
var
 OldROP   : integer;
 hOldPen  : THandle;
 lpP      : PAPOINTS;

begin
 SetMapMode (_hDC, MM_ISOTROPIC);
 if (lpO.bIsDrawn) then
 begin
  OldROP := SetROP2 (_hDC, R2_WHITE);
  lpP:=PAPOINTS(GlobalLock(lpO.hOldPoints));
  if Assigned(lpP) then
    begin
     _ShowObject(_hDC, lpP^, lpO.lpD.lpL^,
		 lpO.lpD.MaxLines);
     GlobalUnLock (lpO.hOldPoints);
    end;
  SetROP2 (_hDC, OldROP);
 end;

 hOldPen:=SelectObject(_hDC, lpO.hPen);
 if (hOldPen<>0) then
 begin
  lpP:=PAPOINTS(GlobalLock(lpO.hPoints));
  if Assigned(lpP) then
  begin
   lpO.bIsDrawn := TRUE;
   _ShowObject(_hDC, lpP^, lpO.lpD.lpL^,
		 lpO.lpD.MaxLines);
   GlobalUnLock (lpO.hPoints);
  end;
  SelectObject (_hDC, hOldPen);
 end;
end;


{-------------------------------------------------------------------------
    Objektum megjelentse adott view-ban
--------------------------------------------------------------------------}

procedure DrawObject(_hDC :HDC; lpV :TVIEW; lpO:CObject);
begin
 ProjectObject (lpV, lpO);
 ShowObject (_hDC, lpO);
end;

function min(a,b :integer):integer;
begin
 if a<b then min:=a
        else min:=b;
end;

{-------------------------------------------------------------------------
    Az ablakkezel fggvny
--------------------------------------------------------------------------}
function _WindowFn(Window: HWnd; Message, WParam: Word;
                    LParam: Longint): Longint; Export ;
var
 PS   : TPAINTSTRUCT;
 _hDC : HDC;
 i,cf : integer;

begin
 _WindowFn:=0;

 case message of

  WM_CREATE:
   begin
     View.Alpha := 0.0;
     View.Beta  := 0.0;
     if (CreateObject(Obj, dCube, RGB(0, 0,$FF))) then
     begin
      SetTimer (Window, TIMER, TIME, nil);
      bInitOk := TRUE;
     end;
    if (Not bInitOk) then  DestroyWindow (Window);
    exit;
   end;

  { a forgatva trtn rajzolst az idzt vezrli }
  WM_TIMER:
   begin
    View.Alpha := View.Alpha + PI/87;
    View.Beta  := View.Beta  + PI/96;
    _hDC := GetDC (Window);
    if (_hDC<>0) then
    begin
     InvalidateRect(Window,nil,TRUE);
     ReleaseDC (Window, _hDC);
    end;
    exit;
   end;

  WM_SIZE:
   begin
    _hDC := GetDC (Window);
    if (_hDC <> 0) then
    begin
     SetMapMode    (_hDC, MM_ISOTROPIC);
     GetClientRect(Window, View.Rect);
     DPtoLP (_hDC, View.Rect, 2);
     ReleaseDC (Window, _hDC);
    end;
    cf := round(min(LOWORD(lParam), HIWORD(lParam))/1.5);
    for i:=0 to MAX_CUBE_COORDS-1 do
    begin
      if cCube[i].x<0 then cCube[i].x :=  -cf
                      else cCube[i].x :=   cf;
      if cCube[i].y<0 then cCube[i].y :=  -cf
                      else cCube[i].y :=   cf;
      if cCube[i].z<0 then cCube[i].z :=  -cf
                      else cCube[i].z :=   cf;
    end;
    InvalidateRect(Window, nil, TRUE);
    exit;
   end;

  WM_PAINT:
   begin
    BeginPaint (Window, PS);
    DrawObject (PS.hdc, View, Obj);
    EndPaint (Window, PS);
    exit;
   end;

  WM_QUERYENDSESSION:
   begin
     _WindowFn:=1;
    exit;
   end;

  WM_DESTROY:
   begin
    if (bInitOk) then
    begin
     KillTimer (Window, TIMER);
     DeleteLPObject (Obj);
    end;
    PostQuitMessage (0);
    exit;
   end;

  else
    _WindowFn:=DefWindowProc(Window, message, wParam, lParam);
 end {Case};
end;

{-------------------------------------------------------------------------
    Az WINMAIN fggvny
--------------------------------------------------------------------------}

procedure WinMain;
const
 bOk : BOOL = TRUE;
var
 msg    : TMsg;
 _hWnd   : HWND;
 WC     : TWNDCLASS ;
 AppName: array[0..MAX_APPNAME] of char;
 AppTitle: array[0..MAX_APPTITLE] of char;

begin
 CpyTxt (AppName,  IDS_APPNAME);
 CpyTxt (AppTitle, IDS_APPTITLE);

 if (hPrevInst=0) then
 begin
  WC.style := CS_VREDRAW or CS_HREDRAW;
  WC.hCursor:= LoadCursor(0, IDC_ARROW);
  WC.hIcon := 0; { LoadIcon(hInst, AppName); }
  WC.lpszMenuName := AppName;
  WC.lpszClassName := AppName;
  WC.hbrBackground := GetStockObject(WHITE_BRUSH);
  WC.hInstance := hInstance;
  WC.lpfnWndProc := @_WindowFn;
  WC.cbClsExtra := 0;
  WC.cbWndExtra := 0;
  bOk := RegisterClass (WC);
 end;

 if (bOk) then
 begin
  _hWnd:=CreateWindow(AppName, AppTitle,
      WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT,
      CW_USEDEFAULT,
      200, 200, 0,0,
      hInstance, nil);

   if (_HWnd<>0) then
      begin
       ShowWindow (_hWnd, cmdShow);
       UpdateWindow(_hWnd);
       while (GetMessage (msg, 0, 0, 0)) do
         begin
	  TranslateMessage (msg);
	  DispatchMessage (msg);
         end;
      end;
 end;
 halt(msg.wParam);
end;

begin
  WinMain;
end.
