unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Const   pn=8;   fn=6; nezopont=200;
        fszog=pi/180;

Type   T3D = record
                 x,y,z : real;
             end;

       F3D = record
  	       p1, p2, p3, p4 : byte;
             end;

       K2D = record
               x,y : integer;
            end;

Var
   Form1: TForm1;
  points: Array [1..pn] of T3D;
    face: Array [1..fn] of F3D;
 Kpoints: Array [1..pn] of K2D;
 Xk, Yk : Integer;

Implementation

{$R *.DFM}

Procedure InitCube;
begin
  points[1].x := -50;
  points[1].y :=  50;
  points[1].z :=  50;

  points[2].x :=  50;
  points[2].y :=  50;
  points[2].z :=  50;

  points[3].x := -50;
  points[3].y := -50;
  points[3].z :=  50;

  points[4].x := -50;
  points[4].y :=  50;
  points[4].z := -50;

  points[5].x :=  50;
  points[5].y :=  50;
  points[5].z := -50;

  points[6].x :=  50;
  points[6].y := -50;
  points[6].z := -50;

  points[7].x := -50;
  points[7].y := -50;
  points[7].z := -50;

  points[8].x :=  50;
  points[8].y := -50;
  points[8].z :=  50;

  face[1].p1 :=   1;
  face[1].p2 :=   2;
  face[1].p3 :=   5;
  face[1].p4 :=   4;

  face[2].p1 :=   4;
  face[2].p2 :=   7;
  face[2].p3 :=   6;
  face[2].p4 :=   5;

  face[3].p1 :=   5;
  face[3].p2 :=   2;
  face[3].p3 :=   8;
  face[3].p4 :=   6;

  face[4].p1 :=   6;
  face[4].p2 :=   7;
  face[4].p3 :=   3;
  face[4].p4 :=   8;

  face[5].p1 :=   8;
  face[5].p2 :=   2;
  face[5].p3 :=   1;
  face[5].p4 :=   3;

  face[6].p1 :=   3;
  face[6].p2 :=   7;
  face[6].p3 :=   4;
  face[6].p4 :=   1;
end;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
   // Ltrehozzuk az alapbra pontjait
   xk:=ClientWidth  div 2;
   yk:=ClientHeight div 2;
   InitCube;
End;

  Procedure Centralis_projekcio;
  var i:byte;
  begin
    for i:=1 to pn do
      begin
        kpoints[i].x:=xk+round(points[i].x * nezopont/(nezopont-points[i].z));
        kpoints[i].y:=yk-round(points[i].y * nezopont/(nezopont-points[i].z));
      end;
  end;

Procedure RotateX;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    points[i].x :=  points[i].x;
    points[i].y :=  points[i].y * cos(fszog) + points[i].z * sin(fszog);
    points[i].z := -points[i].y * sin(fszog) + points[i].z * cos(fszog);
  end;
end;

Procedure RotateY;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    points[i].x := points[i].x * cos(fszog) - points[i].z * sin(fszog);
    points[i].y := points[i].y;
    points[i].z := points[i].x * sin(fszog) + points[i].z * cos(fszog);
  end;
end;

Procedure RotateZ;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    points[i].x :=  points[i].x * cos(fszog) - points[i].y * sin(fszog);
    points[i].y :=  points[i].x * sin(fszog) + points[i].y * cos(fszog);
    points[i].z :=  points[i].z;
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
          case Key of
            'x' : RotateX;
            'y' : RotateY;
            'z' : RotateZ;
         end;
Refresh;

end;

Procedure TForm1.FormPaint(Sender: TObject);
Var i : word;
Begin
Centralis_projekcio; Canvas.pen.Color:=clBlue;
      for i:=1 to Fn do
      begin
        Canvas.moveto(kpoints[face[i].p1].x,kpoints[face[i].p1].y);
        Canvas.lineto(kpoints[face[i].p2].x,kpoints[face[i].p2].y);
        Canvas.lineto(kpoints[face[i].p3].x,kpoints[face[i].p3].y);
        Canvas.lineto(kpoints[face[i].p4].x,kpoints[face[i].p4].y);
        Canvas.lineto(kpoints[face[i].p1].x,kpoints[face[i].p1].y);
        end;
End;

END.
