{$N+}
Program Coons_Hermite3D;

Uses Graph;

Const
       pn = 4;
    scale = 20;
   PontSz = 80;
  nezopont= 90000;
    fszog = pi/180;

Type
  pont3D = record
                  X,Y,Z : real;
           end;

  Tkep  = record
                  X,Y   : integer;
          end;
Var
   kp,ep    : Array[1..pn] of Pont3D;  {Kontrol Pontok}
   kpoints  : Array[1..pn] of Tkep  ;  {3d->2d projekciobol kovetkezo kepkoordinatak}
   k0       : real   ;
   ch,c     : char   ;
   k,i      : word   ;
   ks       : string ;
   xt, yt   : integer;

Function ReadKey:Char; Assembler;
 asm
  xor ah,ah
  int 16h
 end;

Procedure VideoInit;
Var
  hibakod,gd,gm : integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                        writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                        halt(1);
                      end;
   end;

Procedure ErintoSz; {Erinto szamitas}
begin
  case ch of
  'N':begin {nylt grbe esetre}
          ep[1].x:=round( (kp[2].x-kp[1].x )*k0);
          ep[1].y:=round( (kp[2].y-kp[1].y )*k0);
          ep[1].z:=round( (kp[2].z-kp[1].z )*k0);

       ep[pn].x:=round((kp[pn].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[pn].y-kp[pn-1].y)*k0);
       ep[pn].z:=round((kp[pn].z-kp[pn-1].z)*k0);
      end;
  'Z':begin {zrt grbe esetre}
          ep[1].x:=round((kp[2].x-kp[pn].x)*k0);
          ep[1].y:=round((kp[2].y-kp[pn].y)*k0);
          ep[1].z:=round((kp[2].z-kp[pn].z)*k0);
       ep[pn].x:=round((kp[1].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[1].y-kp[pn-1].y)*k0);
       ep[pn].z:=round((kp[1].z-kp[pn-1].z)*k0);
      end;
  end;

  for k:=2 to pn-1 do begin  {mindkt grbe esetn ugyan az}
                       ep[k].x:=round((kp[k+1].x-kp[k-1].x)*k0);
                       ep[k].y:=round((kp[k+1].y-kp[k-1].y)*k0);
                       ep[k].z:=round((kp[k+1].z-kp[k-1].z)*k0);
                      end;
end;

procedure vetit(x,y,z: real);
    {kpskravetts s kpernykoordintk kiszmtsa}
begin
        xt:=320+round((x * nezopont)/(nezopont-z));
        yt:=240-round((y * nezopont)/(nezopont-z));
end;

Procedure RotateX;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
      kp[i].y :=  kp[i].y * cos(fszog) + kp[i].z * sin(fszog);
    kp[i].z := -kp[i].y * sin(fszog) + kp[i].z * cos(fszog);
  end;
end;

Procedure RotateY;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
       kp[i].x := kp[i].x * cos(fszog) - kp[i].z * sin(fszog);
       kp[i].z := kp[i].x * sin(fszog) + kp[i].z * cos(fszog);
  end;
end;

Procedure RotateZ;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    kp[i].x :=  kp[i].x * cos(fszog) - kp[i].y * sin(fszog);
    kp[i].y :=  kp[i].x * sin(fszog) + kp[i].y * cos(fszog);
  end;
end;

Procedure CoonsHGr;

var
  j: integer;
  n, n2, n3, w, z: real;

function xp(i, j: integer): integer; {grbepont x koordintja}
begin
  case ch of
  'N':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      xp:=round(((2*n3-3*n2+1)*kp[i].x+(-2*n3+3*n2)*kp[i+1].x+
                (n3-2*n2+n)*ep[i].x+(n3-n2)*ep[i+1].x)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        xp:=round(((2*n3-3*n2+1)*kp[pn].x+(-2*n3+3*n2)*kp[1].x+
                   (n3-2*n2+n)*ep[pn].x+(n3-n2)*ep[1].x)*scale)
      else
        xp:=round(((2*n3-3*n2+1)*kp[i].x+(-2*n3+3*n2)*kp[i+1].x+
                  (n3-2*n2+n)*ep[i].x+(n3-n2)*ep[i+1].x)*scale);
    end;
  end;
end;

function yp(i, j: integer): integer; {grbepont y koordintja}
begin
  case ch of
  'N':begin
     n:=j/PontSz; n2:=n*n; n3:=n2*n;
     yp:=round(((2*n3-3*n2+1)*kp[i].y+(-2*n3+3*n2)*kp[i+1].y+
               (n3-2*n2+n)*ep[i].y+(n3-n2)*ep[i+1].y)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        yp:=round(((2*n3-3*n2+1)*kp[pn].y+(-2*n3+3*n2)*kp[1].y+
                   (n3-2*n2+n)*ep[pn].y+(n3-n2)*ep[1].y)*scale)
      else
        yp:=round(((2*n3-3*n2+1)*kp[i].y+(-2*n3+3*n2)*kp[i+1].y+
                  (n3-2*n2+n)*ep[i].y+(n3-n2)*ep[i+1].y)*scale);
    end;
  end;
end;

function zp(i, j: integer): integer; {grbepont x koordintja}
begin
  case ch of
  'N':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      zp:=round(((2*n3-3*n2+1)*kp[i].z+(-2*n3+3*n2)*kp[i+1].z+
                (n3-2*n2+n)*ep[i].z+(n3-n2)*ep[i+1].z)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        zp:=round(((2*n3-3*n2+1)*kp[pn].z+(-2*n3+3*n2)*kp[1].z+
                   (n3-2*n2+n)*ep[pn].z+(n3-n2)*ep[1].z)*scale)
      else
        zp:=round(((2*n3-3*n2+1)*kp[i].z+(-2*n3+3*n2)*kp[i+1].z+
                  (n3-2*n2+n)*ep[i].z+(n3-n2)*ep[i+1].z)*scale);
    end;
  end;
end;

begin
  SetColor(15); OutTextXY(1,1,'3D Coons-Hermite Intrpolci');
  SetColor(red); setlinestyle(0,0,3);
  if ch='N' then begin
                  vetit(xp(1,0),yp(1,0),zp(1,0));
                  Moveto(xt,yt);
                end;

  if ch='Z' then begin
                  Vetit(xp(1,0),yp(1,0),zp(1,0));
                  Moveto(xt,yt);
                 end;

  for i:=1 to pn-1 do for j:=1 to PontSz do begin
                                              Vetit(xp(i,j),yp(i,j),zp(i,j));
                                              LineTo(xt,yt);
                                            end;

  if ch='Z' then      for j:=1 to PontSz do begin
                                              Vetit(xp(pn,j),yp(pn,j),zp(pn,j));
                                              Lineto(xt,yt);
                                            end;
end;

Begin
 VideoInit;

   Ch:='N'; k0:=1;
   kp[1].x:=1 ; kp[1].y:=5 ; kp[1].z:=-5;
   kp[2].x:=1 ; kp[2].y:=2 ; kp[2].z:=-3;
   kp[3].x:=-7; kp[3].y:=1 ; kp[3].z:=-1;
   kp[4].x:=-2; kp[4].y:=5 ; kp[4].z:= 4;
                                ErintoSz;
   Repeat
     CoonsHGr; SetFillStyle(1,yellow); SetLineStyle(0,0,0);
      For i:=1 to pn do begin
                         Vetit(kp[i].x*scale,kp[i].y*scale,kp[i].z*scale);
                         FillEllipse(xt,yt,3,3);
                        end;
    C := readkey;
    Case C of
        'x': RotateX;
        'y': RotateY;
        'z': RotateZ;
    End;

    Cleardevice;

    Until C = #27;
       CloseGraph;
End. of program