Program kocka5;

Uses Graph;

Const M=350;
      P=350*65536;

Type
     T3D=record
              x,y,z : longint;
         end;

     TPoint=record
               map    : T3D;
               coords : T3D;
               screen : record
                           a   : byte   ;
                           x,y : integer;
                        end;
            end;

     T3DObject=record
                 points : array[1..8] of TPoint;
             end;
Var
    Cube      : T3DObject;
    Pointnum, Vmode  : Word   ;
    Sint,Cost : array[0..511] of Integer;
    a, b :integer;

Procedure Init_Video(felbontas:word);
 var hibakod,gdriver,gmode:integer;
  begin
  gdriver:=detect;
  initgraph(gdriver,gmode,'');
  hibakod:=graphresult;
  if hibakod<>0 then
    begin
      writeln('GRAFIKUS HIBA: ',grapherrormsg(hibakod));
      halt(1);
    end;
 end;

Function Keypressed:boolean;   assembler;
asm
 mov  ah, 01h  {Get keyboard satus}
 int  16h      {Meghivjuk a BIOS megszakitst}
 mov  al,00h   {00h, azaz FALS}
 jz   @exit
 inc  al       {01h, azaz TRUE}
@exit:         {Visszaadjuk az AL regiszter rtkt}
end;

{---------------------------------------------------------------------------}

Function ReadKey: Char;      assembler;
       asm
       xor ah,ah
       int 16h
      end;

Procedure VerticalRetrace;        {Megvrja amg a VGA vgez az egsz}
Begin                             {kperny frisstsvel, ettl lesz}
  ASM                             {a mozgs szp folyamatos.         }
    MOV DX,$3da
@1: IN AL,DX
     TEST AL,8
    JZ @1
  END;
End;

Procedure Init_Cube;

begin
     {pontok megadasa 65536-al felszorozva}
     Cube.points[1].map.x:=-50*65536;Cube.points[1].map.y:=50*65536;
     Cube.points[1].map.z:=50*65536;
     Cube.points[2].map.x:=50*65536;Cube.points[2].map.y:=50*65536;
     Cube.points[2].map.z:=50*65536;
     Cube.points[3].map.x:=50*65536;Cube.points[3].map.y:=-50*65536;
     Cube.points[3].map.z:=50*65536;
     Cube.points[4].map.x:=-50*65536;Cube.points[4].map.y:=-50*65536;
     Cube.points[4].map.z:=50*65536;
     Cube.points[5].map.x:=-50*65536;Cube.points[5].map.y:=50*65536;
     Cube.points[5].map.z:=-50*65536;
     Cube.points[6].map.x:=50*65536;Cube.points[6].map.y:=50*65536;
     Cube.points[6].map.z:=-50*65536;
     Cube.points[7].map.x:=50*65536;Cube.points[7].map.y:=-50*65536;
     Cube.points[7].map.z:=-50*65536;
     Cube.points[8].map.x:=-50*65536;Cube.points[8].map.y:=-50*65536;
     Cube.points[8].map.z:=-50*65536;
     pointnum:=8;
end;

Procedure FillTabs;
var i : integer;
begin
     for i:=0 to 511 do
     begin
          sint[i]:=round(sin(i*2*pi/511)*256);
          cost[i]:=round(cos(i*2*pi/511)*256);
     end;
end;

Procedure Forgat(Xcor,Ycor:integer);
var psa,pca,psb,pcb,
    pcs,pss,pcc,psc : longint;
    i : integer;
begin
 psa:=sint[a];
 pca:=cost[a];
 psb:=sint[b];
 pcb:=cost[b];
 pcs:=(pca*psb) div 256;
 pss:=(psa*psb) div 256;
 pcc:=(pca*pcb) div 256;
 psc:=(psa*pcb) div 256;

 with Cube do
 begin
  for i:=1 to pointnum do
  begin
   {koordinatak forgatasa}
   Points[i].coords.X:=(-Points[i].map.X*psa+Points[i].map.Y*pca) div 256;
   Points[i].coords.Y:=(-Points[i].map.X*pcs-Points[i].map.Y*pss+Points[i].map.Z*pcb) div 256;
   Points[i].coords.Z:=(-Points[i].map.X*pcc-Points[i].map.Y*psc-Points[i].map.Z*psb) div 256;

   {lekepezes}
   Points[i].screen.X:=longint(Xcor)+((M*(Points[i].coords.X div 256)) div ((P+Points[i].coords.Z) div 256));
   Points[i].screen.Y:=longint(Ycor)+((M*(Points[i].coords.Y div 256)) div ((P+Points[i].coords.Z) div 256));
  end;

 end;
end;

Procedure DrawPontok;
var i : integer;
begin
  for i:=1 to Pointnum do
              PutPixel(Cube.Points[i].screen.X, Cube.Points[i].screen.y,15);
  VerticalRetrace;
  for i:=1 to Pointnum do
              PutPixel(Cube.Points[i].screen.X, Cube.Points[i].screen.y,0 );
end;

Procedure DrawBox(color : byte);
begin
SetColor(color);
 line(Cube.Points[1].screen.x,Cube.Points[1].screen.y,Cube.Points[2].screen.x,Cube.Points[2].screen.y);
 line(Cube.Points[2].screen.x,Cube.Points[2].screen.y,Cube.Points[3].screen.x,Cube.Points[3].screen.y);
 line(Cube.Points[3].screen.x,Cube.Points[3].screen.y,Cube.Points[4].screen.x,Cube.Points[4].screen.y);
 line(Cube.Points[4].screen.x,Cube.Points[4].screen.y,Cube.Points[1].screen.x,Cube.Points[1].screen.y);
 line(Cube.Points[1].screen.x,Cube.Points[1].screen.y,Cube.Points[5].screen.x,Cube.Points[5].screen.y);
 line(Cube.Points[2].screen.x,Cube.Points[2].screen.y,Cube.Points[6].screen.x,Cube.Points[6].screen.y);
 line(Cube.Points[3].screen.x,Cube.Points[3].screen.y,Cube.Points[7].screen.x,Cube.Points[7].screen.y);
 line(Cube.Points[4].screen.x,Cube.Points[4].screen.y,Cube.Points[8].screen.x,Cube.Points[8].screen.y);
 line(Cube.Points[5].screen.x,Cube.Points[5].screen.y,Cube.Points[6].screen.x,Cube.Points[6].screen.y);
 line(Cube.Points[6].screen.x,Cube.Points[6].screen.y,Cube.Points[7].screen.x,Cube.Points[7].screen.y);
 line(Cube.Points[7].screen.x,Cube.Points[7].screen.y,Cube.Points[8].screen.x,Cube.Points[8].screen.y);
 line(Cube.Points[8].screen.x,Cube.Points[8].screen.y,Cube.Points[5].screen.x,Cube.Points[5].screen.y);
Verticalretrace;
end;

Begin
 Init_Video(1);
     Init_Cube;
      FillTabs;
      Repeat
             Forgat(320,200);   {    Forgatas   }
                {drawpontok;}
                 Drawbox(15);   {Kocka rajzolasa}
            a:=(a+1) and 511;
            b:=(b+1) and 511;
                  Drawbox(0);   { Kocka torlese }
            Until Keypressed;
      Readkey;
Closegraph;
End. of program
